import bpy


keys = [
    {
        "keymap": "Object Mode",
        "space_type": "EMPTY",
        "idname": "sectionbox.select",
        "type": "LEFTMOUSE",
        "value": "PRESS",
        "any": True,
    },
    {
        "keymap": "Object Mode",
        "space_type": "EMPTY",
        "idname": "sectionbox.reset",
        "type": "BACK_SPACE",
        "value": "PRESS",
    },
    {
        "keymap": "Object Mode",
        "space_type": "EMPTY",
        "idname": "sectionbox.delete",
        "type": "X",
        "value": "PRESS",
    },
    {
        "keymap": "Object Mode",
        "space_type": "EMPTY",
        "idname": "sectionbox.edge_select",
        "type": "E",
        "value": "PRESS",
    },
]


def register_keymaps():
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    if kc:
        for key in keys:
            name = key.get("keymap")
            space_type = key.get("space_type", "EMPTY")

            km = kc.keymaps.new(name=name, space_type=space_type)
            if km:
                idname = key.get("idname")
                type = key.get("type", "EMPTY")
                value = key.get("value", "PRESS")
                alt = key.get("alt", False)
                shift = key.get("shift", False)
                ctrl = key.get("ctrl", False)
                oskey = key.get("oskey", False)
                any = key.get("any", False)

                kmi = km.keymap_items.new(idname, type=type, value=value, alt=alt, shift=shift, ctrl=ctrl, oskey=oskey)
                if any:
                    kmi.any = True


def unregister_keymaps():
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    if kc:
        for key in keys:
            km = kc.keymaps.get(key.get("keymap"))
            if km:
                kmi = km.keymap_items.get(key.get("idname"))
                if kmi:
                    km.keymap_items.remove(kmi)
