import bpy
from bpy.types import Operator

from ..utils.collection import get_selected_collections


class SECTIONBOX_OT_Create(Operator):
    bl_idname = "sectionbox.create"
    bl_label = "Create"
    bl_description = "Create a section box around all selected objects\nIf no objects selected, an empty section box will be created"
    bl_options = {"UNDO"}

    def execute(self, context):
        if context.area.type == "VIEW_3D":
            context.scene.sectionbox.create(context, context.selected_objects)
        elif context.area.type == "OUTLINER":
            for col in get_selected_collections(context):
                context.scene.sectionbox.create(context, col.all_objects, collection=col)

        return {"FINISHED"}
