import bpy
from bpy.types import Operator

from ..utils.sectionbox import get_sectionbox


class SECTIONBOX_OT_EdgeSelect(Operator):
    bl_idname = "sectionbox.edge_select"
    bl_label = "Edge Mode"
    bl_options = {"INTERNAL"}

    @classmethod
    def poll(cls, context):
        return get_sectionbox(context)

    def invoke(self, context, event):
        self.type = event.type
        context.window_manager.sectionbox.edge_select = True
        context.area.tag_redraw()
        context.window_manager.modal_handler_add(self)
        return {"RUNNING_MODAL"}

    def modal(self, context, event):
        if event.type == self.type and event.value == "RELEASE":
            context.window_manager.sectionbox.edge_select = False
            try:
                context.area.tag_redraw()
            except:
                pass
            return {"CANCELLED"}

        else:
            return {"PASS_THROUGH"}
