import bpy
from bpy.types import Operator

from ..utils.sectionbox import get_sectionbox


class SECTIONBOX_OT_Reload(Operator):
    bl_idname = "sectionbox.reload"
    bl_label = "Reload"
    bl_description = "Synchronize this section box with the collection it was generated from"
    bl_options = {"UNDO"}

    sb_id: bpy.props.IntProperty()

    def execute(self, context):
        sb = get_sectionbox(context, check_active=False)
        if not sb:
            return {"CANCELLED"}

        sb.reload(context)
        self.report({"INFO"}, message=f'Reloaded "{sb.entry_name}" successfully!')
        return {"FINISHED"}
