import bpy
from bpy.types import PropertyGroup


class SECTIONBOX_PG_UI(PropertyGroup):
    sectionbox_settings: bpy.props.BoolProperty()
    sectionplane_settings: bpy.props.BoolProperty()
    sectionplane_transform: bpy.props.BoolProperty()
    sectionplane_cross_section: bpy.props.BoolProperty()
    sectionplane_elevation: bpy.props.BoolProperty()
    cross_section_advanced: bpy.props.BoolProperty()
    elevation_advanced: bpy.props.BoolProperty()
    expand_transform: bpy.props.BoolProperty()
    expand_cross_section: bpy.props.BoolProperty()
    expand_elevation: bpy.props.BoolProperty()
    expand_default_general_settings: bpy.props.BoolProperty()
    expand_default_plane_settings: bpy.props.BoolProperty()
    export_settings: bpy.props.BoolProperty()
    export_format: bpy.props.EnumProperty(
        name="Format",
        description="Export format",
        items=[
            ("dxf", "DXF", "Export as DXF"),
            ("mesh", "Mesh", "Export as Mesh"),
        ],
    )
    expand_clean_up: bpy.props.BoolProperty()
