import bpy
from bpy.types import UIList


class SECTIONBOX_UL_List(UIList):
    def draw_item(self, context, layout, data, item, icon, active_data, active_propname, index):
        sb = item.object.sectionbox
        icon = "CUBE" if not sb.collection else "OUTLINER_COLLECTION"
        if self.layout_type in {"DEFAULT", "COMPACT"}:
            layout.prop(sb, "entry_name", text="", emboss=False, icon=icon)
        elif self.layout_type == "GRID":
            layout.alignment = "CENTER"
            layout.label(text="", icon=icon)

        layout: bpy.types.UILayout
        row = layout.row(align=True)

        if sb.collection:
            row.operator("sectionbox.reload", emboss=False, icon="FILE_REFRESH", text="").sb_id = index

        icon = "CHECKBOX_HLT" if sb.enable else "CHECKBOX_DEHLT"
        row.prop(sb, "enable", text="", emboss=False, icon=icon)
        icon = "HIDE_ON" if sb.hide else "HIDE_OFF"
        row.prop(sb, "hide", text="", emboss=False, icon=icon)
        if sb.method == "BOOLEAN":
            icon = "RESTRICT_RENDER_ON" if sb.hide_render else "RESTRICT_RENDER_OFF"
            col = row.column()
            col.enabled = sb.enable
            col.prop(sb, "hide_render", text="", emboss=False, icon=icon)
