import bpy
import addon_utils

from pathlib import Path


def is_addon_installed(addon_name):
    addons = addon_utils.modules()
    return any(addon_name == Path(a.__file__).parent.name for a in addons)


def is_addon_enabled(addon_name):
    return addon_name in bpy.context.preferences.addons.keys()


def addon_enable(addon_name):
    if not is_addon_installed(addon_name):
        return False

    if not is_addon_enabled(addon_name):
        bpy.ops.preferences.addon_enable(module=addon_name)
        return True


def addon_disable(addon_name):
    if not is_addon_installed(addon_name):
        return False

    if is_addon_enabled(addon_name):
        bpy.ops.preferences.addon_disable(module=addon_name)
        return True
