import bpy


def import_data(path: str, data_type: str, name: str):
    if not name:
        data = None
    else:
        data = getattr(getattr(bpy.data, data_type), name, None)

    if not data:
        with bpy.data.libraries.load(str(path)) as (data_from, data_to):
            data_collection = getattr(data_from, data_type, None)
            if not data_collection:
                return

            if name is None:
                setattr(data_to, data_type, data_collection)
                return data_collection

            try:
                data_id = data_collection.index(name)
            except ValueError as e:
                print(e)
                return

            data = getattr(data_from, data_type)[data_id]
            if data not in getattr(bpy.data, data_type).values():
                getattr(data_to, data_type).append(data)
                return data
