import numpy as np
from mathutils import Vector


plane_rotation = (
    Vector((0, 0, 0)),
    Vector((np.pi, 0, 0)),
    Vector((-np.pi / 2, 0, 0)),
    Vector((np.pi / 2, 0, 0)),
    Vector((0, np.pi / 2, 0)),
    Vector((0, -np.pi / 2, 0)),
)
plane_axis = (2, 2, 1, 1, 0, 0)
plane_name = ("bottom", "top", "front", "back", "left", "right")
plane_rotation_from_face_normal = [
    lambda n: Vector(
        (
            np.pi - Vector((0, 1)).angle_signed(-Vector((n.y, n.z))),
            Vector((0, 1)).angle_signed(-Vector((n.x, n.z))),
            0,
        )
    ),
    lambda n: Vector(
        (Vector((0, 1)).angle_signed(-Vector((n.y, n.z))), Vector((0, 1)).angle_signed(-Vector((n.x, n.z))), 0)
    ),
    lambda n: Vector(
        (
            np.pi / 2 - Vector((1, 0)).angle_signed(-Vector((n.y, n.z))),
            0,
            -Vector((0, 1)).angle_signed(-Vector((n.x, n.y))),
        )
    ),
    lambda n: Vector(
        (
            -np.pi / 2 + Vector((1, 0)).angle_signed(-Vector((n.y, n.z))),
            0,
            -Vector((0, 1)).angle_signed(-Vector((n.x, n.y))),
        )
    ),
    lambda n: Vector(
        (
            0,
            -np.pi / 2 + Vector((1, 0)).angle_signed(-Vector((n.x, n.z))),
            -Vector((1, 0)).angle_signed(-Vector((n.x, n.y))),
        )
    ),
    lambda n: Vector(
        (
            0,
            np.pi / 2 - Vector((1, 0)).angle_signed(-Vector((n.x, n.z))),
            -Vector((1, 0)).angle_signed(-Vector((n.x, n.y))),
        )
    ),
]
