import bpy


stored_settings = {}


def store_settings(object, properties=set()):
    """Store props of object"""
    stored_settings[object] = {}
    settings = stored_settings[object]
    if not properties:
        properties = [p for p in dir(object) if not (callable(getattr(object, p)) or p.startswith("_"))]
    for prop in properties:
        settings[prop] = getattr(object, prop)


def restore_settings(object, properties=set()):
    """Restore props of object"""
    settings = stored_settings.get(object)
    if not settings:
        return
    if not properties:
        properties = settings.keys()
    for prop in properties:
        try:
            setattr(object, prop, settings[prop])
        except:
            continue
